#include <stdlib.h>
//#include <dir.h>
#include <direct.h>
#include <dos.h>
#include <string.h>
#include "globals.h"

find_t Entrie;

int cleanpath(void) {

	char drive[_MAX_DRIVE], dir[_MAX_DIR], name[_MAX_FNAME], ext[_MAX_EXT];
	char *tpath;
	int cdrive = _getdrive();
	unsigned i = 0;

	tpath = (char *)calloc(_MAX_PATH,sizeof(char));
	if (tpath == NULL) return(-8);
	if (_fullpath(tpath,DInfo.Path,_MAX_PATH) == NULL)
		{free(tpath);return(-4);}
	_splitpath(tpath,drive,dir,name,ext);
	free(tpath);

	if (((char)cdrive + 'A' - '\1') != drive[0]) {
		if ((_chdrive((int)(drive[0] - 'A' + '\1'))) !=0)
			return(-6);
		else {
			_chdrive(cdrive);
		}
	}

	_makepath(DInfo.Path,drive,dir,"","");

	i = 0;
	do ++i; while (DInfo.Path[i] != '\0');
	if (i > 3) {
		DInfo.Path[--i] = '\0';
		if ((_dos_findfirst(DInfo.Path, _A_SUBDIR, &Entrie)) != 0) return(-5);
		DInfo.Path[i++] = '\\';
		DInfo.Path[i] = '\0';
	}
	
	if ((name[0] != '\0') || (ext[0] != '\0')) {
		cdrive = 0;
		while ((name[cdrive] != '\0') && (i < _MAX_PATH)) DInfo.Path[i++] = name[cdrive++];
		if (i == _MAX_PATH) return(-9);
		DInfo.Path[i] = '\0';
		cdrive = 0;
		while ((ext[cdrive] != '\0') && (i < _MAX_PATH )) DInfo.Path[i++] = ext[cdrive++];
		if (i == _MAX_PATH) return(-9);
		DInfo.Path[i] = '\0';

		i = 0;
		while (DInfo.Path[i] != '\0') if ((DInfo.Path[i] == '*') || (DInfo.Path[i] == '?')) return(0); else ++i;

		if (_dos_findfirst(DInfo.Path, 0xFF, &Entrie)) return(0);
		if (!(Entrie.attrib & _A_SUBDIR)) return(0);
	}

	if ((i + 4) >= _MAX_PATH) return(0);

	if (DInfo.Path[i - 1] != '\\') DInfo.Path[i++] = '\\';
	DInfo.Path[i++] = '*';
	DInfo.Path[i++] = '.';
	DInfo.Path[i++] = '*';
	DInfo.Path[i] = '\0';


	return(0);
}

int getdirinfo(void) {

	unsigned i = 0, flag = 0;
	int c = 0;
	unsigned long x = 0;
	unsigned long DriveBytes = 0, FreeBytes = 0, TotalBytes = 0, UsedBytes = 0;
	unsigned DBOverflow = 0, FBOverflow = 0, TBOverflow = 0, UBOverflow = 0, BlockSize = 0;
	char rootp[7] = "x:\\*.*";
	char filter = '\0';
	char const uflow[7] = "< 1 KB";
	diskfree_t Free;
	unsigned char drivedata[63];
	unsigned short hes,hdi,hds,hdx,drv;
	unsigned long tclus,fclus,sect,bytes;
	fatinfo fatinf;

	hes = FP_SEG(drivedata);
	hdi = FP_OFF(drivedata);
	hds = FP_SEG(rootp);
	hdx = FP_OFF(rootp);

	rootp[0] = DInfo.Path[0];rootp[3] = '\0';
	drv = (rootp[0] - 'A') + 1;
	getfat((unsigned char)drv,&fatinf);

	_dos_getdiskfree(drv, &Free);
	tclus = Free.total_clusters;
	fclus = Free.avail_clusters;
	sect = Free.sectors_per_cluster;
	bytes = Free.bytes_per_sector;

	if ((_osmajor >= 7) && ((fatinf.fi_fatid & 0x00ff) == 0xf8)) {
		for (i = 0; i < 63; i++) drivedata[i] = '\0';
		asm {
			push ax
			push es
			push di
			push ds
			push dx
			push cx
			mov ax,0x7302
			mov es,[hes]
			mov di,[hdi]
			mov dx,[drv]
			mov cx,0x3f
			int 21h
		}
		if ((drivedata[11] != 0) || (drivedata[12] != 0)) {
			flag = 1;
			goto _GOOD;
		}
		for (i = 0; i < 63; i++) drivedata[i] = '\0';
		asm {
			mov ax,0x7303
			mov es,[hes]
			mov di,[hdi]
			mov ds,[hds]
			mov dx,[hdx]
			mov cx,0x2c
			int 21h
			jnc _GOOD
		}
		flag = 1;
_GOOD:
		asm {
			pop cx
			pop dx
			pop ds
			pop di
			pop es
			pop ax
		}
		if (flag == 0) {
			tclus = 0;fclus = 0;bytes = 0;sect = 0;
			x = 1;
			for (c = 0; c < 4; c++) {
				if (c > 0) x *= 256;
				tclus += (unsigned long)drivedata[16 + c] * x;
				fclus += (unsigned long)drivedata[12 + c] * x;
				bytes += (unsigned long)drivedata[8 + c] * x;
				sect += (unsigned long)drivedata[4 + c] * x;
			}
		} else flag = 0;
	}

	BlockSize = sect * bytes;

	for (i = 0; i < BlockSize; i++) {
		DriveBytes += tclus;
		if (DriveBytes < tclus) ++DBOverflow;
		FreeBytes += fclus;
		if (FreeBytes < fclus) ++FBOverflow;
	}

	rootp[3] = '*';
	i = _dos_findfirst(rootp, _A_LABEL, &Entrie);
	if(!i && (Entrie.attrib & _A_LABEL)) {
		while ((Entrie.name[flag] != '\0') && (Entrie.name[flag] != '.')) ++flag;
		if (Entrie.name[flag] == '\0') {
			while ((Entrie.name[DInfo.LLen] != 0) && (DInfo.LLen < (_MAX_LABEL - 1)))
				DInfo.DLabel[DInfo.LLen] = Entrie.name[DInfo.LLen++];
			DInfo.DLabel[DInfo.LLen] = '\0';
		} else {
			for (c = 0; c < flag; c++)
				DInfo.DLabel[DInfo.LLen++] = Entrie.name[c];
			while ((Entrie.name[++c] != '\0') && (DInfo.LLen < (_MAX_LABEL - 1)))
				DInfo.DLabel[DInfo.LLen++] = Entrie.name[c];
			DInfo.DLabel[DInfo.LLen] = '\0';
		}
	}

	if ((bgiven.dplace & 3) == 3) filter = ~(_A_LABEL | _A_SUBDIR);
		else filter = ~(_A_LABEL);

	i = _dos_findfirst(DInfo.Path, filter, &Entrie);
	while (!i) {
		x = Entrie.size / BlockSize;
		if ((Entrie.size % BlockSize) != 0) ++x;
		UsedBytes += (x * BlockSize);
		if (UsedBytes < (x * BlockSize)) ++UBOverflow;
		TotalBytes += Entrie.size;
		if (TotalBytes < Entrie.size) ++TBOverflow;
		if (Entrie.attrib & _A_SUBDIR) {
			++DInfo.TDirectories;
			if (DInfo.TDirectories == 0) return(-7);
		} else {
			++DInfo.TFiles;
			if (DInfo.TFiles == 0) return(-7);
		}
	i = _dos_findnext(&Entrie);
	}

	if (tscreen.columns < 40) {
		if ((DBOverflow == 0) && (DriveBytes < 1000)) for (c = 0; c < 7; c++) DInfo.DriveSize[c] = uflow[c];
		else textval(DInfo.DriveSize,DBOverflow,DriveBytes,6);
		if ((FBOverflow == 0) && (FreeBytes < 1000)) for (c = 0; c < 7; c++) DInfo.DriveFree[c] = uflow[c];
		else textval(DInfo.DriveFree,FBOverflow,FreeBytes,6);
	} else {
		textval(DInfo.DriveSize,DBOverflow,DriveBytes,9);
		textval(DInfo.DriveFree,FBOverflow,FreeBytes,9);
	}

	if (tscreen.columns < 60) {
		if ((TBOverflow == 0) && (TotalBytes < 1000)) for (c = 0; c < 7; c++) DInfo.TBytes[c] = uflow[c];
		else textval(DInfo.TBytes,TBOverflow,TotalBytes,6);
		if ((UBOverflow == 0) && (UsedBytes < 1000)) for (c = 0; c < 7; c++) DInfo.UBytes[c] = uflow[c];
		else textval(DInfo.UBytes,UBOverflow,UsedBytes,6);
	} else {
		textval(DInfo.TBytes,TBOverflow,TotalBytes,9);
		textval(DInfo.UBytes,UBOverflow,UsedBytes,9);
	}


	return(0);
}

int getlist(void) {

	unsigned i = 0, c = 0, x = 0, m = 0;
	unsigned char filter = '\0';

	if ((bgiven.dplace & 3) == 3) filter = ~(_A_LABEL | _A_SUBDIR);
		else filter = ~(_A_LABEL);

	i = _dos_findfirst(DInfo.Path,filter,&Entrie);
	while (!i) {
		if (c == TList) return(-8);
		flist[c].attrib = Entrie.attrib;
		flist[c].size = Entrie.size;
		flist[c].date = Entrie.wr_date;
		flist[c].time = Entrie.wr_time;

		if (((Entrie.name[0] == '.') && (Entrie.name[1] == '\0')) || \
		((Entrie.name[0] == '.') && (Entrie.name[1] == '.') && (Entrie.name[2] == '\0'))) {
			while (Entrie.name[x] != '\0') {flist[c].name[x] = Entrie.name[x];++x;}
			flist[c].name[x] = '\0';
			flist[c].ext[0] = '\0';
		} else {
			while ((Entrie.name[x] != '.') && (Entrie.name[x] != '\0'))
				flist[c].name[x] = Entrie.name[x++];
			flist[c].name[x] = '\0';
			if (Entrie.name[x] != '\0') ++x;
			while (Entrie.name[x] != '\0') flist[c].ext[m++] = Entrie.name[x++];
			flist[c].ext[m] = '\0';
		}
		++c;x = 0;m = 0;
		i = _dos_findnext(&Entrie);
	}

	return(0);
}

